#include <Arduino.h>
#include <Wire.h>
#include <String.h>
#include "Display.h"

const uint8_t FONT[] = {
  0b00111111, // 0
  0b00000110, // 1
  0b01011011, // 2
  0b01001111, // 3
  0b01100110, // 4
  0b01101101, // 5
  0b01111101, // 6
  0b00000111, // 7
  0b01111111, // 8
  0b01101111, // 9
  0b01110111, // A
  0b01111100, // B
  0b00111001, // C
  0b01011110, // D
  0b01111001, // E
  0b01110001, // F
  0b01000000  // -
}; 

Display::Display() {
	Wire.begin();
}

void Display::sendChar(uint8_t pos, uint16_t num) {
	Wire.beginTransmission(I2C);
	Wire.write(pos);
	if(num == 255)Wire.write(0);
	else Wire.write(FONT[num]);
	Wire.endTransmission();
}

void Display::sendNumUnsigned(uint16_t num) {
	String temp = String(num);

	if(num > 9999) {
		for(int i = 0; i <= 3; i++) {
			sendChar(i, 16);
		}		
	}

	if(temp.length() == 4) {


		sendChar(3, (uint8_t)temp.charAt(3) - '0');
		sendChar(2, (uint8_t)temp.charAt(2) - '0');
		sendChar(1, (uint8_t)temp.charAt(1) - '0');
		sendChar(0, (uint8_t)temp.charAt(0) - '0');
		
	}

	if(temp.length() == 3) {
		sendChar(3, (uint8_t)temp.charAt(2) - '0');
		sendChar(2, (uint8_t)temp.charAt(1) - '0');
		sendChar(1, (uint8_t)temp.charAt(0) - '0');
		sendChar(0, 255);
	}

	if(temp.length() == 2) {
		sendChar(3, (uint8_t)temp.charAt(1) - '0');
		sendChar(2, (uint8_t)temp.charAt(0) - '0');
		sendChar(1, 255);
		sendChar(0, 255);
	}

	if(temp.length() == 1) {
		sendChar(3, (uint8_t)temp.charAt(0) - '0');
		sendChar(2, 255);
		sendChar(1, 255);
		sendChar(0, 255);
	}
}

void Display::sendNumSigned(int16_t num) {
	String temp = String(num);

	if(num > 9999 || num < -999) {
		for(int i = 0; i <= 3; i++) {
			sendChar(i, 16);
		}		
	}

	if(num > 0) {
		sendNumUnsigned(num);
		return;
	}

	if(temp.length()-1 == 3) {


		sendChar(3, (uint8_t)temp.charAt(3) - '0');
		sendChar(2, (uint8_t)temp.charAt(2) - '0');
		sendChar(1, (uint8_t)temp.charAt(1) - '0');
		sendChar(0, 16);
		
	}

	if(temp.length()-1 == 2) {
		sendChar(3, (uint8_t)temp.charAt(2) - '0');
		sendChar(2, (uint8_t)temp.charAt(1) - '0');
		sendChar(1, 16);
		sendChar(0, 255);
	}

	if(temp.length()-1 == 1) {
		sendChar(3, (uint8_t)temp.charAt(1) - '0');
		sendChar(2, 16);
		sendChar(1, 255);
		sendChar(0, 255);
	}

	if(temp.length() == 1) {
		sendChar(3, (uint8_t)temp.charAt(0) - '0');
		sendChar(2, 255);
		sendChar(1, 255);
		sendChar(0, 255);
	}
}

