#include "Arduino.h"
#include "Termistor.h"

#define RESISTOR	10000

Termistor::Termistor(uint8_t pin) {
	pinMode(pin, INPUT);
	_pin = pin;

}

int8_t Termistor::getTempC() {
  float temperature, resistance;
	int a;
	a = analogRead(A1);
	resistance = (float)(1023-a)*RESISTOR/a; 
	int B = 3975;

	temperature  = 1/(log(resistance/RESISTOR)/B+1/298.15)-273.15;
	return (int8_t)temperature;
}

int8_t Termistor::getTempF() {
	return getTempC() * 9 / 5 + 32;
}
